precision highp float;

varying vec4 positionVarying;
varying vec2 texcoordVarying;

uniform vec4 texelIncrement;
uniform sampler2D screenTexture;

const vec2 leftTop   = vec2( -1, -1 );
const vec2 centerTop = vec2( 0, -1 );
const vec2 rightTop = vec2( 1, -1 );

const vec2 leftMiddle   = vec2( -1, 0 );
const vec2 rightMiddle = vec2( 1, 0 );

const vec2 leftBottom   = vec2( -1, 1 );
const vec2 centerBottom = vec2( 0, 1 );
const vec2 rightBottom = vec2( 1, 1 );


void main()
{
    float d = 0.0;
    vec4 resultColor = texture2D( screenTexture, texcoordVarying ) * 0.25;
    resultColor += texture2D( screenTexture, leftTop * texelIncrement.xy + texcoordVarying ) * 0.0625;
    resultColor += texture2D( screenTexture, centerTop * texelIncrement.xy + texcoordVarying ) * 0.125;
    resultColor += texture2D( screenTexture, rightTop * texelIncrement.xy + texcoordVarying ) * 0.0625;
    resultColor += texture2D( screenTexture, leftMiddle * texelIncrement.xy + texcoordVarying ) * 0.125;
    resultColor += texture2D( screenTexture, rightMiddle * texelIncrement.xy + texcoordVarying ) * 0.125;
    resultColor += texture2D( screenTexture, leftBottom * texelIncrement.xy + texcoordVarying ) * 0.0625;
    resultColor += texture2D( screenTexture, centerBottom * texelIncrement.xy + texcoordVarying ) * 0.125;
    resultColor += texture2D( screenTexture, rightBottom * texelIncrement.xy + texcoordVarying ) * 0.0625;
    
    gl_FragColor = resultColor;
}