precision highp float;

attribute vec4 position;
attribute vec4 normal;
varying vec2 texcoordVarying;
varying vec4 diffuseVarying;

uniform mat4 mvp;
uniform vec4 globalScale;
//uniform vec4 diffuseColor;

const vec3 lightDirection01 = vec3( 0, 0, 1 );
const vec3 lightDirection02 = vec3( 0, -1, 0 );
const vec3 lightDirection03 = vec3( 0.5773502691896258, 0.5773502691895258, 0.5773502691896258 );

const float nWeight = 1.0 / 127.0;
const float uvWeight = 1.0 / 256.0;


void main()
{
    
    float underShading = min( 1.0, smoothstep( 0.0, 4.0, position.z ) + 0.93 );
    
    vec3 n = vec3( normal.x, normal.y, normal.z ) * nWeight;
    texcoordVarying.x = ( normal.w + 128.5 ) * uvWeight;
    texcoordVarying.y = 0.25;
    
    float light01Dot = dot( lightDirection01, n.xyz );
    float light02Dot = dot( lightDirection02, n.xyz );
    float light03Dot = dot( lightDirection03, n.xyz );
    
    light01Dot = ( light01Dot + 1.0 ) * 0.5;
    light02Dot = ( light02Dot + 1.0 ) * 0.5;
    light03Dot = ( light03Dot + 1.0 ) * 0.5;
    float color = smoothstep( 0.0, 1.0,light01Dot * 0.6 + light02Dot * 0.35 + light03Dot * 0.25 + 0.3 );
    diffuseVarying = vec4( color * underShading, color * underShading, color * underShading, 1.0 );
    
    gl_Position = mvp * vec4( position.x, position.y, position.z * globalScale.z, 1.0 );
}