uniform sampler2D u_diffuse_texture;

varying vec4 v_line_info;
varying vec4 v_pattern_info;

void main()
{
    float a = mod( v_line_info.w, v_pattern_info.z ) / v_pattern_info.z;
    vec4 pattern = texture2D( u_diffuse_texture, vec2( v_pattern_info.x, v_pattern_info.y + a * v_pattern_info.w ));
    vec4 line = texture2D( u_diffuse_texture, v_line_info.xy );
    
    float ma = 1.0 - pattern.a;
    gl_FragColor = vec4( ma * line.rgb + pattern.a * pattern.rgb, ma * line.a + pattern.a );
}
