attribute vec3 a_position;
attribute vec2 a_uv;

uniform sampler2D u_diffuse_texture;
uniform mat4 u_mvp;
uniform vec4 u_palette_info;   // x, y : per pixel uv of an atlas( pallete ) texture
                            //    z : 0 : stroke, 1: line body
                            
uniform vec4 u_view_info;   // x : distance per unit pixel 
                            // y : display scale

uniform vec4 u_view_level;   // x : view( map ) level ( int part )
                             // y : view level ( flaot part )


varying vec4 v_diffuse;

const float int16_scale = 0.00006103515625;

void main()
{
    float offset = ( u_view_level.y ) * u_palette_info.x;
    vec2 uv = vec2( a_uv.x * int16_scale + offset, a_uv.y * int16_scale );
    v_diffuse = texture2D( u_diffuse_texture, uv );
    
    gl_Position = u_mvp * vec4( a_position, 1.0 );
}
