#version 450

//attribute
layout (location = 0) in vec4 a_position;
layout (location = 1) in vec4 a_normal;
layout (location = 2) in vec4 a_line;
layout (location = 3) in vec4 a_pattern;

//varying
layout (location = 4) out vec4 v_line_info;
layout (location = 6) out vec4 v_pattern_info;

//uniform
layout (set = 0, binding = 0) uniform Block
{
    mat4 u_mvp;
    float u_unit_pixel_distance;
} block;

void main()
{
    v_line_info = vec4( a_line.xy, a_line.z * block.u_unit_pixel_distance, a_position.w );
    v_pattern_info = vec4( a_pattern.xy, a_pattern.z * block.u_unit_pixel_distance, a_pattern.w );
    vec2 pos_xy = a_position.xy + a_normal.xy * v_line_info.z;
    gl_Position = block.u_mvp * vec4( pos_xy, a_position.z, 1.0 );
}
